/*
 * SegunValoresParejaDeCamposIgualesDep.java
 *
 * Created on 29 de mayo de 2007, 10:22 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * 
 * @author JSolano
 */
public class SegunValoresParejaDeCamposIgualesDep extends AbstractRule {
	// COL?1=?2 AND (COL?3 NOT IN(?4) AND @campo=COL?5 AND COL?6=COL?7)
	//
	/** Creates a new instance of CampoVacio */
	public SegunValoresParejaDeCamposIgualesDep() {
	}

	public void setParams(Object[] params) {
		String valores = (String) params[3];
		ArrayList<String> listaString = new ArrayList<String>();
		StringTokenizer st = new StringTokenizer(valores, ",");
		while (st.hasMoreTokens()) {
			listaString.add(st.nextToken());
		}
		String[] array = listaString.toArray(new String[listaString.size()]);
		Arrays.sort(array);
		params[3] = array;

		super.setParams(params);
	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {
		String codigoNovedad = registro[new Integer((String) getParams()[0])
				.intValue()];
		if (!codigoNovedad.equals((String) getParams()[1])) {
			return false;
		}
		String campo = registro[new Integer((String) getParams()[2]).intValue()];
		String campo2 = registro[new Integer((String) getParams()[4])
				.intValue()];
		String campo3 = registro[new Integer((String) getParams()[5])
				.intValue()];
		String campo4 = registro[new Integer((String) getParams()[6])
				.intValue()];
		if (Arrays.binarySearch((String[]) getParams()[3], campo) < 0
				&& field.equals(campo2) && campo3.equals(campo4)) {
			return true;
		}

		return false;

	}

}
